var overviewTimeout;
var numOverviewPics = 0;
var currentDisplay = "logo";
var currentIndex = 5;
var currentLoopImages;


$(document).ready(function() {
    console.log("Locked and loaded!");
});


function displayOverview(urls) {
    $("#individual").fadeOut(1000);
    $("#overview").empty();
    addOverviewPictures(urls);
    $("#overview").fadeIn(1000);
    currentDisplay = "overview";    
}


function displayID() {
    $("#overview").fadeOut(1000);
    $("#overview").empty();
    $("#id").fadeIn(1000);
    currentDisplay = "id";
}


function displayGroup() {
    $("#overview").fadeOut(1000);
    $("#overview").empty();
    $("#id").fadeOut(1000);
    $("#individual").fadeOut(1000);
    $("#quad_1").empty();
    $("#quad_2").empty();
    $("#quad_3").empty();
    $("#quad_4").empty();
    $("#group").fadeIn(2000);	
    currentDisplay = "group";
}


function displayIndividual() {
    $("#group").fadeOut(1000);
    $("#quad_1").empty();
    $("#quad_2").empty();
    $("#quad_3").empty();
    $("#quad_4").empty();
    $("#img_loop").empty();

    for (var i = 0; i < currentLoopImages.length; i++) {
	var tag = '<div class="slot">';
	tag += '<img id="thumb_' + i + '" src="' + makeLocalThumb(currentLoopImages[i].url) + '" class="thumb_' + currentLoopImages[i].orientation + '" /></div>';
	$("#img_loop").append(tag);
    }

    $("#individual").fadeIn(2000);
    currentDisplay = "individual";
}


function showPicture(url, orientation, numStars) {
    $("#current_img").fadeOut(200, function() {
	$("#current_img").removeClass();
	$("#current_img").addClass("current_" + orientation);
	$("#current_img").attr("src", url);
	setZoom();
	$("#current_img").fadeIn(200);
    });

    $("#stars").fadeOut(200, function() {
	$("#stars").removeClass();
	$("#stars").addClass("stars_" + orientation);
	showStars(numStars);
	$("#stars").fadeIn(200);
    });
}


function addOverviewPictures(urls) {

    var x = [-10, 5, 10, 20, 30, 50, 55, 60, 75, 75];
    var y = [30, 20, 80, -20, 30, 75, 15, -10, 65, 20];
    var rotations = [-30, 30, -10, 30, 10, 30, 25, -35, -5, 30];

    for(var i = 0; i < 10; i++) {
	var rotation = "-webkit-transform:rotate(" + rotations[i] + "deg);";

	var position = "position: absolute; top:" + y[i] + "%; left:" + x[i] + "%;";
	var css = position + " " + rotation;
	var tag = '<img id="' + numOverviewPics + '" src="' + makeLocal(urls[i].url) + '" class="overview_img_' + urls[i].orientation +'" style="' + css + '" />';
	
	$("#overview").append(tag);
    }
}


function addGroupPicture(url, orientation, quadrant) {
    var sign = Math.round(Math.random()) > 0.5 ? 1 : -1; 
    var css = "-webkit-transform:rotate(" + Math.random() * 12.5 * sign + "deg);";
    if(orientation == "h")
	css += "width: 108px; height: 72px";
    else
	css += "width: 72px; height: 108px";
    $("#quad_" + quadrant).append('<img src="' + url + '" class="thumb_' + orientation + '" style="' + css + '" />');
}


function updateSlot(slotNum, url, orientation) {
    $("#s" + slotNum).html('<img src="' + url + '" class="thumb_' + orientation + '" />');
}


function rotateLeft(numPhotos) {
    var oldIndex = currentIndex;
    currentIndex = Math.max(currentIndex - numPhotos, 0);
    if(oldIndex == currentIndex) return;
    $("#thumb_" + oldIndex).removeClass("thumb_glow")
    $("#thumb_" + currentIndex).addClass("thumb_glow")
    var dif = oldIndex - currentIndex;
    $("#img_loop").animate({
	left: '+=' + (dif * 174)
    }, 1000);
    var currentImage = currentLoopImages[currentIndex];
    showPicture(makeLocal(currentImage.url), currentImage.orientation, currentImage.rating);
}


function rotateRight(numPhotos) {
    var oldIndex = currentIndex;
    currentIndex = Math.min(currentIndex + parseInt(numPhotos), currentLoopImages.length - 1);
    if(oldIndex == currentIndex) return;
    $("#thumb_" + oldIndex).removeClass("thumb_glow")
    $("#thumb_" + currentIndex).addClass("thumb_glow")
    var dif = currentIndex - oldIndex;
    $("#img_loop").animate({
	left: '-=' + (dif * 174)
    }, 1000);
    var currentImage = currentLoopImages[currentIndex];
    showPicture(makeLocal(currentImage.url), currentImage.orientation, currentImage.rating);
}


function showStars(numStars) {
    for (var i = 1; i <= 5; i++) {
	if(i <= numStars)
	    $("#" + i + "_star").html('<img src="images/star.png" class="star"/>');
	else
	    $("#" + i + "_star").html('<img src="images/emptyStar.png" class="star"/>');
    }
}

function setZoom() {
    var img = currentLoopImages[currentIndex];
    $("#zoom_img").removeClass();
    $("#zoom_img").addClass(img.orientation);
    $("#zoom_img").attr("src", makeLocalLarge(img.url));
}


function zoomIn() {
    $("#large").fadeIn(600);
}


function zoomOut() {
    $("#large").fadeOut(600);
}


function makeLocal(url) {
    return "http://128.12.10.37:3780/" + url.substr(url.indexOf('/', 3));
}


function makeLocalThumb(url) {
    var target = "http://128.12.10.37:3780/" + url.substr(url.indexOf('/', 3));
    target = target.substring(0, target.length - 4) + "thumbnail.jpg";
    return target;
}


function makeLocalLarge(url) {
    var target = "http://128.12.10.37:3780/" + url.substr(url.indexOf('/', 3));
    target = target.substring(0, target.length - 4) + "large.jpg";
    return target;
}


function capitaliseFirstLetter(string)
{
    return string.charAt(0).toUpperCase() + string.slice(1);
}