var socket = io.connect('http://128.12.10.37:3780'); //Remember to change port number to nodejs
//var socket = io.connect('http://192.168.183.134:3780'); //Remember to change port number to nodejs
var lastRating = 0;

$(document).ready(function() {
    //window.history.replaceState('Object', 'Title', 'http://kinpics.stanford.edu/');
});


socket.on('proximity', function (data) {
    console.log("Proximity", data);
});

socket.on('idle', function (data) {
    console.log("Idle", data);
    //location.reload(true);
    $("#logo").hide();
    $("#group").hide();
    $("#id").hide();
    $("#individual").hide();
    $("#large").hide();
    displayOverview(data.photos);
});


socket.on('identifying', function (data) {
    $("#logo").hide();
    displayID();
    //console.log("Identifying", data);
});


socket.on('identified', function (data) {
    $("#logo").hide();
    //console.log("Identified", data);
    $("#name").fadeOut(400, function() {
	$("#name").html(capitaliseFirstLetter(data.user.name));
	$("#name").fadeIn(600);
    });
    /*$("#user_photo").fadeOut(400, function() {
	$("#user_photo").attr("src", makeLocal(data.user.photo));
	$("#user_photo").fadeIn(600);
    });*/
});


socket.on('photodesk', function (data) {
    $("#logo").hide();
    displayGroup();
    //console.log("PhotoDesk", data);
});


socket.on('quadrant1', function (data) {
    //console.log("Quad1", data);
    $("#quad_1").empty();
    for(var i = 0; i < data.length; i++) {
	addGroupPicture(makeLocalThumb(data[i].url), data[i].orientation, 1);
    }
});

socket.on('quadrant2', function (data) {
    //console.log("Quad2", data);
    $("#quad_2").empty();
    for(var i = 0; i < data.length; i++) {
	addGroupPicture(makeLocalThumb(data[i].url), data[i].orientation, 2);
    }
});

socket.on('quadrant3', function (data) {
    //console.log("Quad3", data);
    $("#quad_3").empty();
    for(var i = 0; i < data.length; i++) {
	addGroupPicture(makeLocalThumb(data[i].url), data[i].orientation, 3);
    }
});

socket.on('quadrant4', function (data) {
    //console.log("Quad4", data);
    $("#quad_4").empty();
    for(var i = 0; i < data.length; i++) {
	addGroupPicture(makeLocalThumb(data[i].url), data[i].orientation, 4);
    }
});

socket.on('photodesk/swipeleft', function (data) {
    //console.log("DeskLeft");
});

socket.on('photodesk/swiperight', function (data) {
    //console.log("DeskRight");
});

socket.on('hover', function (data) {
    console.log(data);

    for (var i = 1; i < 5; i++) {
	$("#quad_" + i + " > img").removeClass("hover");
    }

    $("#quad_" + data + " > img").addClass("hover");
});

socket.on('browsing', function (data) {
    //console.log("Browsing", data);
    currentLoopImages = data;
    var midIndex = Math.floor(data.length / 2);
    currentIndex = midIndex;
    $("#img_loop").removeAttr("style");
    $("#img_loop").animate({
	left: '-=' + ((midIndex - 3.25) * 174)});
    displayIndividual();
    $("#thumb_" + currentIndex).addClass("thumb_glow")
    showPicture(makeLocal(data[midIndex].url), data[midIndex].orientation, data[midIndex].rating); 
});

socket.on('browsing/scrollright', function (data) {
    //console.log("Scroll Right", data);
    rotateRight(data);
});

socket.on('browsing/scrollleft', function (data) {
    //console.log("Scroll Left", data);
    rotateLeft(data);
});


socket.on('ratingchange', function (data) {
    //console.log("Rating Change", data);
    lastRating = data;
    currentLoopImages[currentIndex].rating = lastRating;
    showStars(lastRating);
});

socket.on('ratingfinish', function (data) {
    //console.log("Rating Finish", data);
    currentLoopImages[currentIndex].rating = lastRating;
    socket.emit("lastrating", {"id" : currentLoopImages[currentIndex].id, "rating" : lastRating});
    console.log(currentLoopImages[currentIndex].id);
});

socket.on('usericon', function (data) {
    //console.log("User Icon", data);
});


socket.on('position', function (data) {
    //console.log("Position", data);
    var left_x = data.left_x * 1280;
    var left_y = data.left_y * 800;
    var right_x = data.right_x * 1280;
    var right_y = data.right_y * 800;
    $("#left_hand").css({top: (left_y - 96/2) + "px", left: (left_x - 96/2) +"px", opacity: data.left_opacity});
    $("#right_hand").css({top: (right_y - 96/2) + "px", left: (right_x - 96/2) +"px", opacity: data.left_opacity});

});

socket.on('zoomin', function(data) {
    //console.log("Zoom In");
    zoomIn();
});

socket.on('zoomout', function(data) {
    //console.log("Zoom Out");
    zoomOut();
});

socket.on('refresh', function(data) {
    location.reload(true);
});

socket.on('notification', function(data) {
    //console.log("Notification", data);
    $("#notification_message").html(data);
    $("#notification_message").fadeIn(1000, function() {
	$("#notification_message").delay(2000).fadeOut(1000);
    });
    if("New Photo Uploaded!" == data) {
	var v = document.getElementsByTagName("audio")[0]
	v.play();
    }
});